//---------------------------------------------------------------------------


#pragma hdrstop

#include "SmartImage.h"
//---------------------------------------------------------------------------
__fastcall TSmartImage::TSmartImage(TComponent* nOwner, TWinControl* nParent)
{

  siName = "Image";
  siPath = ".";
  siFileName = siPath + "\\Delete.bmp";
  siOwner = nOwner;
  siParent = nParent;
  siImagePresent = true;

  SetObjects();

  siImage->Picture->LoadFromFile(siFileName);

  SetImageProp();

}
//---------------------------------------------------------------------------
__fastcall TSmartImage::TSmartImage(TComponent* nOwner, TWinControl* nParent, int nIndex)
{
  if(nIndex < 10)
      siName = "Image0" + (AnsiString)nIndex ;
  else
      siName = "Image" + (AnsiString)nIndex ;

  siPath = ".";
  siFileName = siPath + "\\Delete.bmp";
  siOwner = nOwner;
  siParent = nParent;
  siImagePresent = false;

  SetObjects();

  SetImageProp();

}
//---------------------------------------------------------------------------
__fastcall TSmartImage::TSmartImage(TComponent* nOwner, TWinControl* nParent, AnsiString nFileName)
{

  siOwner = nOwner;
  siParent = nParent;
  siFileName = nFileName;
  GetPath();
  GetName();
  SetObjects();

  try
  {
    siImage->Picture->LoadFromFile(siFileName);
    siImagePresent = true;


    SetImageProp();
  }
  catch(...)
  {
    siFileError = FE_Def;
    siImagePresent = false;

  }
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::SetObjects(void)
{
	siGBox        = new TGroupBox(siOwner);
	siPanel       = new TPanel(siOwner);
  siIterLB      = new TLabel(siOwner);
  siScaleLB     = new TLabel(siOwner);
  siCoordLB     = new TLabel(siOwner);
  siIconBoxLB   = new TLabel(siOwner);
  siColorCB     = new TCheckBox(siOwner);
  siStatus      = new TStatusBar(siOwner);
  siImage       = new TImage(siOwner);
  siScale       = DEF_SCALE;
  siIter        = DEF_ITER;
  siUseColor    = false;
  siUseCoord    = false;
  siUseIconBox  = false;
  siOnColor     = clWhite;
  siOffColor  = clBlack;

  SetGBoxProp();

}
//---------------------------------------------------------------------------
__fastcall TSmartImage::~TSmartImage(void)
{
  delete siImage;
  delete siPicture;
  delete siGBox;
  //delete siIterLB;
  //delete siScaleLB;
  //delete siColorCB;

}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::SetImageProp(void)
{
  siImage->Align = alClient;

  siXCornerMin = siWidth - SIZEBOX_X;
  siYCornerMin = siHeight - SIZEBOX_Y;


  siImage->Parent = siGBox;
  siImage->Align = alClient;

  siImage->Proportional = true;
  siImage->Center = true;
  siImage->IncrementalDisplay = true;
  //siImage->OnProgress = DoProgress;

  siImage->ShowHint = true;
  siImage->Hint = siName +
                  '\n' +
                  "Size: w=" + (AnsiString)siImage->Picture->Width +
                  " x h=" +
                  (AnsiString)siImage->Picture->Height;

  siImage->OnMouseDown = GroupBoxMouseDown;
  siImage->OnMouseMove = GroupBoxMouseMove;
  siImage->OnMouseUp = GroupBoxMouseUp;
  CalcScale();
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::SetGBoxProp(void)
{
	//---set the smart image dimensions and placement---
	siWidth = GB_WIDTH;
	siHeight = GB_HEIGHT;
	siTop = GB_TOP;
	siLeft = GB_LEFT;
	siXCornerMin = siWidth - SIZEBOX_X;
	siYCornerMin = siHeight - SIZEBOX_Y;

	//---Set the scale and the iterations and offset---
	siScale = DEF_SCALE;
	siIter = DEF_ITER;
  siXOffset = 0;
  siYOffset = 0;

	//---Set up the Group box---
	siGBox->Parent = siParent;
	siGBox->Width = siWidth;
	siGBox->Height = siHeight;
	siGBox->Top = siTop;
	siGBox->Left = siLeft = 5;
	siGBox->Padding->Left = 5;
	siGBox->Padding->Right = 5;
	siGBox->Padding->Bottom = 5;

	siGBox->Caption = siName;
	siGBox->TabStop = true;
	siGBox->TabOrder = 0;
  siGBox->OnMouseDown = GroupBoxMouseDown;
	siGBox->OnMouseMove = GroupBoxMouseMove;
	siGBox->OnMouseUp = GroupBoxMouseUp;

  //---Set up the status bar---
  siStatus->Parent = siGBox;
  siStatus->SimpleText = siName;
  siStatus->Align = alBottom;


	//---Set up the panel---
	siPanel->Parent = siGBox;
	siPanel->Align = alTop;
	siPanel->Height = 20;
	//siPanel->BevelEdges = [beLeft | beRigt];
  siPanel->BevelInner = bvLowered;
	// = beLeft | beTop | beRight | beBottom;

	//---Set up the Iteration label---
	siIterLB->Parent = siPanel;
	siIterLB->Caption = "Iterations:" + (AnsiString)siIter;
	siIterLB->Align = alLeft;
	siIterLB->Width = 90;
  siIterLB->Height = 16;

	//---Set up the Scale label---
	siScaleLB->Parent = siPanel;
	siScaleLB->Caption = "Scale: " + (AnsiString)siScale;
	siScaleLB->Align = alLeft;
	siScaleLB->Width = 75;
  siScaleLB->Height = 16;

	//---Set up the Color Checkbox---
	siColorCB->Parent = siPanel;
	siColorCB->Caption = "User Color";
	siColorCB->Checked = siUseColor;
	siColorCB->Align = alLeft;
  siColorCB->Height = 16;
	siColorCB->Width = 85;
	siColorCB->OnClick = ChangeColorUse;


}
//---------------------------------------------------------------------------
AnsiString TSmartImage::GetPath(void)
{
    int PathDelim;

    PathDelim = siFileName.LastDelimiter('\\');
    siPath = siFileName.SubString(0,PathDelim);


    return siPath;
}


//---------------------------------------------------------------------------
AnsiString TSmartImage::GetName(void)
{
    int PathDelim;

    PathDelim = siFileName.LastDelimiter('\\');
    siName = siFileName.SubString(PathDelim+1,siFileName.Length() - PathDelim);

    return siName;
}
//---------------------------------------------------------------------------

void __fastcall TSmartImage::GroupBoxMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    if(Button == mbLeft) {
        //---Save the position where the mouse button was clicked
        siLastX = X;
        siLastY = Y;

        //---Calculate the dimensions of the sizing corner---
        siXCornerMin = (siGBox->Width -20 );
        siYCornerMin = (siGBox->Height -30 );

        //---Bring the current image to the front---
        siGBox->BringToFront();

        //---If the mouse was clicked in the sizing corner, we're in sizing
        //---mode
        if (X > siXCornerMin &&
            X < siGBox->Width &&
            Y > siYCornerMin &&
            Y < siGBox->Height) {
            siGBox->Cursor = crSizeNWSE;
            siImage->Cursor = crSizeNWSE;
            siSizing = true;
        }
        //---If outside sizing box, we're in dragging mode---
        else {
            siGBox->Cursor = crDrag;
            siImage->Cursor = crDrag;
            siDragging = true;
        }
    }
    else if (Button == mbRight) {
        int OffX = ((TForm*)siOwner)->Left + ((TGroupBox*)siParent)->Left;
        int OffY = 60 + ((TForm*)siOwner)->Top + ((TGroupBox*)siParent)->Top;

        if(siPMenu != NULL) {
            siPMenu->Popup(siGBox->Left + OffX + X, siGBox->Top + OffY + Y);
            siPMenu->Tag = siIndex;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::GroupBoxMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{

  //---Calc new Group box position---
  if(siDragging)
  {

    siGBox->Top += Y - siLastY;
    siGBox->Left += X - siLastX;

    if (siGBox->Top < -X)
      siGBox->Top = -X + GB_OFFSET;

    if (siGBox->Top > siParent->Width + X)
      siGBox->Top = siParent->Width + X - GB_OFFSET;

    if(siGBox->Left < -Y)
      siGBox->Left = -Y + GB_OFFSET;

    if(siGBox->Left > siParent->Height + Y)
      siGBox->Left = siParent->Height + Y - GB_OFFSET;



    siGBox->Caption = "X=" +
                      (AnsiString)siGBox->Left +
                      ", Y=" +
                      (AnsiString)siGBox->Top;

    siGBox->Cursor = crDrag;
    siImage->Cursor = crDrag;
  }
  //---We're not dragging---
  else
  {
    //---Resize the Group box---
    if(siSizing)
    {
      siGBox->Width = X + 10;
      siGBox->Height = Y + 20;
      siXCornerMin = (siGBox->Width - SIZEBOX_X);
      siYCornerMin = (siGBox->Height - SIZEBOX_Y);

      CalcScale();

      siGBox->Caption = "W= " +
                        (AnsiString)siImage->Picture->Width +
                        ", H= " +
                        (AnsiString)siImage->Picture->Height +
                        " " +
                        (AnsiString)siZoom +
                        "%";
      siStatus->SimpleText = "Image H:" + (AnsiString)siImage->Height +
                             " W:" + (AnsiString)siImage->Width +
                             "Box H:" + (AnsiString)siGBox->ClientHeight +
                             " W:" + (AnsiString)siGBox->ClientWidth;

    }

    //---Change the cursor---
    if (X > siXCornerMin &&
        X < siGBox->Width &&
        Y > siYCornerMin &
        Y <siGBox->Height)
    {
      siGBox->Cursor = crSizeNWSE;
      siImage->Cursor = crSizeNWSE;
    }
    else
    {
      //siGBox->Cursor = crDefault;
      //siImage->Cursor = crDefault;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::GroupBoxMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    siDragging = false;
    siSizing = false;
    siGBox->Caption = siName;
    siGBox->Cursor = crDefault;
		siImage->Cursor = crDefault;
		siImage->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::GroupBoxClick(TObject *Sender)
{
    //siSelected = true;
    //siGBox->Font->Style = TFontStyles() << fsBold;
    siSelected = !siSelected;
    Select(siSelected);

}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::Select(bool nSel) {
    siSelected = nSel;

    if(siSelected)
        siGBox->Font->Style = TFontStyles() << fsBold;
    else
        siGBox->Font->Style = (TFontStyles)0;

    siTNode->Selected = siSelected;
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::SetGBoxPos(int nX, int nY) {
    siGBox->Left = nX;
    siGBox->Top = nY;
    siGBox->BringToFront();

}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::SetGBoxSize(int nW, int nH) {
    siGBox->Width = nW;
    siGBox->Height = nH;
    siGBox->BringToFront();
    siMin = false;
    siMax = false;
    CalcScale();
}

//---------------------------------------------------------------------------
void __fastcall TSmartImage::MinGBox(void) {
    siGBox->Width = GB_MIN_WIDTH;
    siGBox->Height = GB_MIN_HEIGHT;
    siMin = true;
    siMax = false;
    CalcScale();
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::MaxGBox(void) {
    siImage->Width = siImage->Picture->Width;
    siImage->Height = siImage->Picture->Height;

    siGBox->Width = 20 + (siImage->Picture->Width +  siGBox->Width - siImage->Width);
    siGBox->Height = 20 + (siImage->Picture->Height +  siGBox->Height - siImage->Height);
    siMin = false;
    siMax = true;
    CalcScale();
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::CalcScale(void) {
  if(siImagePresent)
    siZoom =  ((float)siImage->Width / (float)siImage->Width ) * 100;
  else
    siZoom = 1;

}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::Draw(void)
{
  int i;
  float xtemp;
  float ytemp;
  int check_val;
  float xScale;
  float yScale;
  float xt;
  float yt;

  int xPix;
  int yPix;
  AnsiString Temp;
  int siProgress;
  int siTotal;
  bool toggle = false;
  TColor TempColor;

  delete siImage;
  siImage = new TImage(siOwner);
  SetImageProp();


  //---Get the panel dimensions---
  siXRange =(siImage->Width/2) + siXOffset;
  siYRange = (siImage->Height/2) + siYOffset;

  siTotal = siImage->Width + siImage->Height;

  siStatus->SimpleText = "Image H:" + (AnsiString)siImage->Height +
                         " W:" + (AnsiString)siImage->Width + " Redrawing...";



  siXo = siXRange;
  siYo = siYRange;

  //---Disable the GUI controls---
  siBusy = true;
  siImage->Cursor = crHourGlass;

  //---Get the color spread---
	//color_scale = 16777215 / Iter;

	TempColor = clBlack;

	if(siRed)
		TempColor |= RED_MASK;

	if(siGreen)
		TempColor |= GREEN_MASK;

	if(siBlue)
		TempColor |= BLUE_MASK;

	siColorScale = TempColor / siIter;

	/*
	if(siRed && siGreen && siBlue)
		siColorScale = 0x00FFFFFF / siIter;
	else
	{
		//---No red---
		if(!siRed)
		{
			//---Green only---
			if(siGreen && !siBlue)
				siColorScale = 0x0000ff00 / siIter;
			//---Blue only---
			else if(!siGreen && siBlue)
				siColorScale = 0x000000ff / siIter;
			//---Blue & green---
			else
				siColorScale = 0x00ffff / siIter;
			//---No blue & no green & no red is handled implicitly: no color---
		}
		//---Red and ...---
		else
		{



    }

  }
	*/

	//color_scale = 0x00FF0000 / Iter;
  //color_scale = 0xFF / Iter;

	/*
	//---Draw a dashed line around the perimeter---
	for(int x = 0; x < siImage->Width; x++)
	{
		toggle = !toggle;
		TempColor = (TColor)toggle;
		siImage->Canvas->Pixels[x][0] = TempColor;
		siImage->Canvas->Pixels[x][siImage->Height - 1] = TempColor;
	}

	for(int y = 0; y < siImage->Height; y++)
	{
		toggle = !toggle;
		TempColor = (TColor)toggle;
		siImage->Canvas->Pixels[0][y] = TempColor;
		siImage->Canvas->Pixels[siImage->Width -1][y] = TempColor;
	}
  */

  for(int x = -siXRange; x < siXRange; x++)
  {
    for(int y = -siYRange; y < siYRange; y++)
    {
      xt = (float)(x/siScale);
      yt = (float)(y/siScale);
      xScale = xt;
      yScale = yt;


      i = 0;

      xtemp = 0;
      ytemp = 0;

      //while(((xt*xt + yt*yt) <= 4) && i < MAX_ITER)
      while(((xt*xt + yt*yt) <= 4) && i < siIter)
      {
        xt = xtemp * xtemp - ytemp * ytemp + xScale;

        yt = 2 * xtemp * ytemp + yScale;

        i++;
        xtemp = xt;
        ytemp = yt;
      }

       xPix = x + siXo;
       yPix = y + siYo;

      if(i >= siIter)
        siImage->Canvas->Pixels[xPix][yPix] = siOffColor;
      else
      {
        if(siUseColor)
          siImage->Canvas->Pixels[xPix][yPix] = (TColor)(i * siColorScale);
        else
          siImage->Canvas->Pixels[xPix][yPix] = siOnColor;
      }
      //siProgress++;
      //siGBox->Caption = (AnsiString)siProgress + " out of " + (AnsiString)siTotal;
    }
  }



  if(siUseCoord)
    siDoCoord();

  if(siUseIconBox)
    siDoIconBox();

  siBusy = false;
  siImagePresent = true;
  siImageSaved = false;
  siImage->Cursor = crDefault;

	siStatus->SimpleText = "Image H:" + (AnsiString)siImage->Height +
												 " W:" + (AnsiString)siImage->Width + "Redraw done";

}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::ChangeColorUse(TObject *Sender)
{
  siUseColor = siColorCB->Checked;

}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::DoProgress(TObject *Sender)
{
  //siGBox->Caption = "Progress: " + PercentDone;

}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::ReScale(bool upDn)
{
  if(upDn)
    siScale = siScale*2;
  else
    siScale = siScale/2;



  if(siScale < MIN_SCALE)
    siScale = MIN_SCALE;

  if(siScale > MAX_SCALE)
    siScale = MAX_SCALE;

  siScaleLB->Caption =  "Scale: " + (AnsiString)siScale;

  Draw();
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::DoOffset(bool dir, bool up)
{
  /*---dir = 1: X
   *   dir = 0: Y
   *   up = 1: up
   *   up = 0: down
   */

  if(dir)
  {
    if(up)
      siXOffset += DEF_OFFSET_INC;
    else
      siXOffset -= DEF_OFFSET_INC;
  }
  else
  {
    if(up)
      siYOffset += DEF_OFFSET_INC;
    else
      siYOffset -= DEF_OFFSET_INC;
  }
  Draw();


}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::siSaveToFile(AnsiString nFilename)
{
  siImage->Picture->SaveToFile(nFilename);
  siImageSaved = true;
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::siDoCoord(void)
{
  int xTen = TICK_INTV;
  int yTen = TICK_INTV;
  bool firstXL = false;
  bool firstXR = false;
  bool firstYU = false;
  bool firstYD = false;
  TColor TempColor = clTeal;
  int Xo = siImage->Width/2;
  int Yo = siImage->Height/2;


  //---Do the x-axis and tick marks---
  //---Do the axis in two halves, starting at the origin and work out---
  for(int x = 0; x < siXRange; x++)
  {
    siImage->Canvas->Pixels[x + Xo][Yo] = clWhite;

    if(xTen == TICK_INTV)
    {
      for(int xTic = -TICK_HALF; xTic < TICK_HALF; xTic++)
        siImage->Canvas->Pixels[x + Xo][xTic + Yo] = TempColor;

      xTen = 0;
      TempColor = clWhite;
    }
    else
      xTen++;
  }

  xTen = TICK_INTV;
  TempColor = clTeal;


  for(int x = 0; x > -siXRange; x--)
  {
    siImage->Canvas->Pixels[x + Xo][Yo] = clWhite;

    if(xTen == TICK_INTV)
    {
      for(int xTic = -TICK_HALF; xTic < TICK_HALF; xTic++)
      {
        siImage->Canvas->Pixels[x + Xo][xTic + Yo] = TempColor;

      }
      TempColor = clWhite;
      xTen = 0;
    }
    else
      xTen++;
  }


  xTen = TICK_INTV;
  yTen = TICK_INTV;
  TempColor = clTeal;

  //---Do the y-axis and tick marks---
  //---Do the axis in two halves, starting at the origin and work out---
  for(int y = 0; y < siYRange; y++)
  {
    siImage->Canvas->Pixels[Xo][y + Yo] = clWhite;

    if(yTen == TICK_INTV)
    {
      for(int yTic = -TICK_HALF; yTic < TICK_HALF; yTic++)
      {
        siImage->Canvas->Pixels[yTic + Xo][y + Yo] = TempColor;
      }
      yTen = 0;
      TempColor = clWhite;
    }
    else
      yTen++;
  }

  yTen = TICK_INTV;
  TempColor = clTeal;

  for(int y = 0; y > -siYRange; y--)
  {
    siImage->Canvas->Pixels[Xo][y + Yo] = clWhite;

    if(yTen == TICK_INTV)
    {
      for(int yTic = -TICK_HALF; yTic < TICK_HALF; yTic++)
      {
        siImage->Canvas->Pixels[yTic + Xo][y + Yo] = TempColor;
      }

      yTen = 0;
      TempColor = clWhite;
    }
    else
      yTen++;
  }
}
//---------------------------------------------------------------------------
void __fastcall TSmartImage::siDoIconBox(void)
{
  int Xo = siImage->Width/2;
  int Yo = siImage->Height/2;

  for(int i = -15; i < 16; i++)
  {
    siImage->Canvas->Pixels[i + Xo][Yo + 15] = clWhite;
    siImage->Canvas->Pixels[i + Xo][Yo - 15] = clWhite;
    siImage->Canvas->Pixels[Xo + 15][Yo + i] = clWhite;
    siImage->Canvas->Pixels[Xo - 15][Yo + i] = clWhite;

  }
}

//---------------------------------------------------------------------------
__fastcall TKeyAssign::TKeyAssign(TComponent *Owner, char nChar) {
    kaKey = (char)(nChar);
    kaSImage = NULL;
    kaSSound = NULL;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
__fastcall TSmartSound::TSmartSound(TMediaPlayer *nMP, AnsiString nFileName)
{
    ssFileName = nFileName;
    ssPath = ssGetPath();
    ssName = ssGetName();

    ssMP = nMP;

    try
    {

        if(ssMP->DeviceID == 0) {
            ssMP->Open();
            Sleep(1000);
        }
        else {
            ssMP->Close();
            ssMP->Open();
        }

        ssMP->FileName = ssFileName;
        ssMP->Play();
    }
    catch(...)
    {
        ssFileError = FE_Def;
    }

}
//---------------------------------------------------------------------------
AnsiString TSmartSound::ssGetPath(void)
{
    int PathDelim = 0;

    PathDelim = ssFileName.LastDelimiter('\\');
    ssPath = ssFileName.SubString(0,PathDelim);


    return ssPath;
}
//---------------------------------------------------------------------------
AnsiString TSmartSound::ssGetName(void)
{
    int PathDelim = 0;

    PathDelim = ssFileName.LastDelimiter('\\');
    ssName = ssFileName.SubString(PathDelim+1,ssFileName.Length() - PathDelim);

    return ssName;
}
//---------------------------------------------------------------------------



#pragma package(smart_init)
