//---------------------------------------------------------------------------

#ifndef SmartImageH
#define SmartImageH


#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <jpeg.hpp>
#include <MPlayer.hpp>
//---------------------------------------------------------------------------
#define SIZEBOX_X       20
#define SIZEBOX_Y       30

#define IMG_TOP         10
#define IMG_LEFT        10

#define IMG_WIDTH       300
#define IMG_HEIGHT      300


#define GB_TOP					10
#define GB_LEFT					10
#define GB_OFFSET       30
#define GB_MINSIZE      100
#define GB_MIN_WIDTH    200
#define GB_MIN_HEIGHT   120
#define GB_SPACE        10
#define GB_WIDTH        IMG_HEIGHT + 300
#define GB_HEIGHT       IMG_HEIGHT + 30

#define LB_TOP          15
#define LB_LEFT         20

#define X_MIN 350
#define Y_MIN 350
#define X_MAX 500
#define Y_MAX 500

#define CANVAS_OFFSET 29+68

#define DEF_RANGE 250

#define MIN_ITER 1000
#define DEF_ITER 2000
#define MAX_ITER 10000

#define MIN_SCALE 1.0
#define DEF_SCALE 125.0
#define MAX_SCALE 1000.0

#define DEF_OFFSET_INC  10

#define TICK_HALF 5

#define TICK_INTV 20

#define DEF_MASK 0x00FFFFFF
#define RED_MASK 0x00FF0000
#define BLUE_MASK 0x000000FF
#define GREEN_MASK 0x0000FF00

enum Ferrs {FE_No_Err, FE_Def, FE_Def1};

//---------------------------------------------------------------------------

class TSmartImage : public TObject
{
    private:
        int siLastX;
        int siLastY;
        bool siDragging;
        bool siSizing;

        int siXCornerMin;
        int siYCornerMin;
        
        
     public:
        TWinControl *siParent;
        TComponent *siOwner;
        TTreeNode *siTNode;
        TImage *siImage;
				TGroupBox *siGBox;
				TPanel *siPanel;
        TLabel *siIterLB;
        TLabel *siScaleLB;
        TLabel *siCoordLB;
        TLabel *siIconBoxLB;
        TCheckBox *siColorCB;
        TStatusBar *siStatus;

        TPicture *siPicture;
        TPopupMenu* siPMenu;
        AnsiString siPath;
        AnsiString siName;
        AnsiString siFileName;

        TColor siOffColor;
        TColor siOnColor;

        bool siSelected;
        bool siMin;
        bool siMax;
        bool siImagePresent;
        bool siBusy;
        bool siUseColor;
        bool siUseCoord;
        bool siUseIconBox;
				bool siImageSaved;
				bool siBlue;
				bool siRed;
				bool siGreen;

        int siWidth;
        int siHeight;
        int siTop;
        int siLeft;
        int siIndex;
        int siZoom;
        int siFileError;

        int siXRange;
        int siYRange;
        int siXOffset;
        int siYOffset;
        int siXo;
        int siYo;
        float siScale;

        int siColorScale;

        int siIter;

        //---Class constructors, destructors, etc---
        __fastcall TSmartImage(TComponent* nOwner, TWinControl* nParent);
        __fastcall TSmartImage(TComponent* nOwner, TWinControl* nParent, int nIndex);
        __fastcall TSmartImage(TComponent* nOwner, TWinControl* nParent, AnsiString nFileName);
        __fastcall ~TSmartImage(void);
        void __fastcall SetParent(TWinControl* nParent)
            { siParent = nParent;}

        AnsiString GetName(void);
        AnsiString GetPath(void);
        void __fastcall SetObjects(void);
        void __fastcall SetImageProp(void);
        void __fastcall SetGBoxProp(void);
        void __fastcall Select(bool nSel);
        void __fastcall SetGBoxPos(int nX, int nY);
        void __fastcall SetGBoxSize(int nW, int nH);

        void __fastcall MinGBox(void);
        void __fastcall MaxGBox(void);
        void __fastcall CalcScale(void);

        //---Event handlers---
        void __fastcall GroupBoxMouseDown(TObject *Sender, TMouseButton Button,
                                          TShiftState Shift, int X, int Y);
        void __fastcall GroupBoxMouseMove(TObject *Sender, TShiftState Shift,
                                                       int X, int Y);
        void __fastcall GroupBoxMouseUp(TObject *Sender, TMouseButton Button,
                                                     TShiftState Shift, int X, int Y);
        void __fastcall GroupBoxClick(TObject *Sender);

        void __fastcall Draw(void);
        void __fastcall ChangeColorUse(TObject *Sender);
        void __fastcall ReScale(bool upDn);
        void __fastcall DoProgress(TObject *Sender);
        void __fastcall DoOffset(bool dir, bool up);
        void __fastcall siDoCoord(void);
        void __fastcall siDoIconBox(void);

        //---File event handlers---
        void __fastcall siSaveToFile(AnsiString nFilename);
};

//---------------------------------------------------------------------------
class TSmartSound : public TObject
{
    public:
        TMediaPlayer *ssMP;
        AnsiString ssFileName;
        AnsiString ssPath;
        AnsiString ssName;
        int ssIndex;
        int ssFileError;

        __fastcall TSmartSound(TMediaPlayer *nMP, AnsiString nFileName);
        AnsiString ssGetName(void);
        AnsiString ssGetPath(void);
};
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
class TKeyAssign : public TObject
{
    public:
        TSmartImage *kaSImage;
        TSmartSound *kaSSound;

        char kaKey;
        int  kaIndex;

        __fastcall TKeyAssign(TComponent *Owner, char nChar);
};
#endif
